//+------------------------------------------------------------------+
//|                                                   count_pips.mq4 |
//|                                     Copyright  2006, Nick Bilak |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nick Bilak"
#property link      "http://www.forex-tsd.com/"
#property show_inputs
extern string start_date="2006.01.20"; //yyyy.mm.dd
extern string finish_date="2006.01.27";
extern bool count_opened=true;

#define SymList 20
string SymbolNames[] = {"USDCHF","GBPUSD","USDJPY","EURUSD","USDCAD","EURGBP","EURCHF","EURJPY","GBPJPY","EURCAD","EURAUD","CHFJPY","USDSEK","USDNOK","USDSGD","USDDKK","NZDUSD","USDZAR","AUDUSD","GBPCHF"};
int pips[SymList];

int start()  {
   int total=HistoryTotal();
   int i,sp;
   datetime start=StrToTime(start_date);
   datetime finish=StrToTime(finish_date);
   datetime ordertime;
   for (i=total-1;i>=0;i--) {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
      ordertime=OrderCloseTime();
      if (ordertime>finish || ordertime<start) continue;
      sp=SymPos(OrderSymbol());
      if (sp>=0) {
         if (OrderType()==OP_BUY)
            pips[sp] += (OrderClosePrice()-OrderOpenPrice())/MarketInfo(SymbolNames[sp],MODE_POINT);
         if (OrderType()==OP_SELL)
            pips[sp] += (OrderOpenPrice()-OrderClosePrice())/MarketInfo(SymbolNames[sp],MODE_POINT);
      }
   }
   if (count_opened) {
      total=OrdersTotal();
      for (i=total-1;i>=0;i--) {
         if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
         sp=SymPos(OrderSymbol());
         if (sp>=0) {
            if (OrderType()==OP_BUY)
               pips[sp] += (OrderClosePrice()-OrderOpenPrice())/MarketInfo(SymbolNames[sp],MODE_POINT);
            if (OrderType()==OP_SELL)
               pips[sp] += (OrderOpenPrice()-OrderClosePrice())/MarketInfo(SymbolNames[sp],MODE_POINT);
         }
      }
   }
   for (i=0; i<SymList; i++) {
      if (pips[i]!=0)
         Print(SymbolNames[i]+" : "+pips[i]);
   }
   return(0);
}

int SymPos(string sym) {
   int i,pos=-1;
   for(i=0;i<ArraySize(SymbolNames);i++)
      if (SymbolNames[i]==sym) { pos=i; break; }
   return(pos);
}